#include <iostream>
#include <string>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    string s="";
    int n,c,q,l,r,zb,ind,br;
    cin>>n>>c>>q;
    cin.ignore();
    getline(cin,s);
    bool a[n];

    for(int i=0;i<n;i++)
        a[i]=s[i]=='1';

    for(int y=0;y<q;y++)
    {
        cin>>l>>r;
        l--;
        for(int i=l;i<r;i++)
            a[i]=!a[i];
        zb=0;
        ind=0;

        while(ind<n)
        {
            if(!a[ind])
                ind++;
            else
            {
                br=1;
                if(++ind==n)
                {
                    zb++;
                    break;
                }

                while(a[ind++])
                {
                    br++;
                    if(ind==n)
                        break;
                }
                if(br>c)
                    zb+=c;
                else
                    zb+=br;
            }
        }
        cout<<zb;
    }





    return 0;
}